(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('@angular/core'), require('@angular/common/http'), require('marked'), require('rxjs/operators')) :
	typeof define === 'function' && define.amd ? define(['@angular/core', '@angular/common/http', 'marked', 'rxjs/operators'], factory) :
	(global.ngx = global.ngx || {}, global.ngx.markdown = factory(global.ng.core,global.ng.common.http,global.marked,global.rxjs.operators));
}(this, (function (core_1,http,marked,operators) { 'use strict';

core_1 = core_1 && core_1.hasOwnProperty('default') ? core_1['default'] : core_1;
http = http && http.hasOwnProperty('default') ? http['default'] : http;
marked = marked && marked.hasOwnProperty('default') ? marked['default'] : marked;
operators = operators && operators.hasOwnProperty('default') ? operators['default'] : operators;

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};



function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var language_pipe = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });

var LanguagePipe = /** @class */ (function () {
    function LanguagePipe() {
    }
    LanguagePipe.prototype.transform = function (value, language) {
        if (typeof value !== 'string') {
            console.error("LanguagePipe has been invoked with an invalid value type [" + value + "]");
            return value;
        }
        if (typeof language !== 'string') {
            console.error("LanguagePipe has been invoked with an invalid parameter [" + language + "]");
            return value;
        }
        return '```' + language + '\n' + value + '\n```';
    };
    LanguagePipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'language',
                },] },
    ];
    return LanguagePipe;
}());
exports.LanguagePipe = LanguagePipe;

});

unwrapExports(language_pipe);
var language_pipe_1 = language_pipe.LanguagePipe;

var markedOptions = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
var MarkedOptions = /** @class */ (function () {
    function MarkedOptions() {
    }
    return MarkedOptions;
}());
exports.MarkedOptions = MarkedOptions;

});

unwrapExports(markedOptions);
var markedOptions_1 = markedOptions.MarkedOptions;

var markdown_service = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });





var MarkdownService = /** @class */ (function () {
    function MarkdownService(http$$1, options) {
        this.http = http$$1;
        this.options = options;
        if (!this.renderer) {
            this.renderer = new marked.Renderer();
        }
    }
    Object.defineProperty(MarkdownService.prototype, "renderer", {
        get: function () { return this.options.renderer; },
        set: function (value) { this.options.renderer = value; },
        enumerable: true,
        configurable: true
    });
    MarkdownService.prototype.compile = function (markdown, markedOptions$$1) {
        if (markedOptions$$1 === void 0) { markedOptions$$1 = this.options; }
        var precompiled = this.precompile(markdown);
        return marked(precompiled, markedOptions$$1);
    };
    MarkdownService.prototype.getSource = function (src) {
        var _this = this;
        return this.http
            .get(src, { responseType: 'text' })
            .pipe(operators.map(function (markdown) { return _this.handleExtension(src, markdown); }));
    };
    MarkdownService.prototype.highlight = function () {
        if (typeof Prism !== 'undefined') {
            Prism.highlightAll(false);
        }
    };
    MarkdownService.prototype.handleExtension = function (src, markdown) {
        var extension = src
            ? src.split('.').splice(-1).join()
            : null;
        return extension !== 'md'
            ? '```' + extension + '\n' + markdown + '\n```'
            : markdown;
    };
    MarkdownService.prototype.precompile = function (markdown) {
        if (!markdown) {
            return '';
        }
        var indentStart;
        return markdown
            .replace(/\&gt;/g, '>')
            .split('\n')
            .map(function (line) {
            // find position of 1st non-whitespace character
            // to determine the markdown indentation start
            if (line.length > 0 && isNaN(indentStart)) {
                indentStart = line.search(/\S|$/);
            }
            // remove whitespaces before indentation start
            return indentStart
                ? line.substring(indentStart)
                : line;
        }).join('\n');
    };
    MarkdownService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    MarkdownService.ctorParameters = function () { return [
        { type: http.HttpClient, },
        { type: markedOptions.MarkedOptions, },
    ]; };
    return MarkdownService;
}());
exports.MarkdownService = MarkdownService;

});

unwrapExports(markdown_service);
var markdown_service_1 = markdown_service.MarkdownService;

var markdown_component = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });


var MarkdownComponent = /** @class */ (function () {
    function MarkdownComponent(element, markdownService) {
        this.element = element;
        this.markdownService = markdownService;
        this.error = new core_1.EventEmitter();
    }
    Object.defineProperty(MarkdownComponent.prototype, "data", {
        get: function () { return this._data; },
        set: function (value) {
            this._data = value;
            this.render(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MarkdownComponent.prototype, "src", {
        get: function () { return this._src; },
        set: function (value) {
            var _this = this;
            this._src = value;
            this.markdownService
                .getSource(value)
                .subscribe(function (markdown) { return _this.render(markdown); }, function (error) { return _this.error.emit(error); });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MarkdownComponent.prototype, "isTranscluded", {
        get: function () {
            return !this.data && !this.src;
        },
        enumerable: true,
        configurable: true
    });
    MarkdownComponent.prototype.ngAfterViewInit = function () {
        if (this.isTranscluded) {
            this.render(this.element.nativeElement.innerHTML);
        }
    };
    MarkdownComponent.prototype.render = function (markdown) {
        this.element.nativeElement.innerHTML = this.markdownService.compile(markdown);
        this.markdownService.highlight();
    };
    MarkdownComponent.decorators = [
        { type: core_1.Component, args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'markdown, [markdown]',
                    template: '<ng-content></ng-content>',
                    styles: [":host /deep/ table{border-spacing:0;border-collapse:collapse;margin-bottom:16px}:host /deep/ table td,:host /deep/ table th{padding:6px 13px;border:1px solid #ddd}:host /deep/ table tr:nth-child(2n){background-color:rgba(0,0,0,.03)}:host /deep/ blockquote{padding:0 1em;color:rgba(0,0,0,.535);border-left:.25em solid rgba(0,0,0,.11)}"],
                },] },
    ];
    /** @nocollapse */
    MarkdownComponent.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
        { type: markdown_service.MarkdownService, },
    ]; };
    MarkdownComponent.propDecorators = {
        "data": [{ type: core_1.Input },],
        "src": [{ type: core_1.Input },],
        "error": [{ type: core_1.Output },],
    };
    return MarkdownComponent;
}());
exports.MarkdownComponent = MarkdownComponent;

});

unwrapExports(markdown_component);
var markdown_component_1 = markdown_component.MarkdownComponent;

var markdown_pipe = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });


var MarkdownPipe = /** @class */ (function () {
    function MarkdownPipe(markdownService, zone) {
        this.markdownService = markdownService;
        this.zone = zone;
    }
    MarkdownPipe.prototype.transform = function (value) {
        var _this = this;
        if (typeof value !== 'string') {
            console.error("MarkdownPipe has been invoked with an invalid value type [" + value + "]");
            return value;
        }
        var markdown = this.markdownService.compile(value);
        this.zone.runOutsideAngular(function () {
            // glitch in the UI... need a better way to handle this!
            setTimeout(function () { return _this.markdownService.highlight(); });
        });
        return markdown;
    };
    MarkdownPipe.decorators = [
        { type: core_1.Pipe, args: [{
                    name: 'markdown',
                },] },
    ];
    /** @nocollapse */
    MarkdownPipe.ctorParameters = function () { return [
        { type: markdown_service.MarkdownService, },
        { type: core_1.NgZone, },
    ]; };
    return MarkdownPipe;
}());
exports.MarkdownPipe = MarkdownPipe;

});

unwrapExports(markdown_pipe);
var markdown_pipe_1 = markdown_pipe.MarkdownPipe;

var markdown_module = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });






exports.initialMarkedOptions = {
    provide: markedOptions.MarkedOptions,
    useValue: {
        gfm: true,
        tables: true,
        breaks: false,
        pedantic: false,
        sanitize: false,
        smartLists: true,
        smartypants: false,
    },
};
var MarkdownModule = /** @class */ (function () {
    function MarkdownModule() {
    }
    MarkdownModule.forRoot = function (markdownModuleConfig) {
        return {
            ngModule: MarkdownModule,
            providers: [
                markdown_service.MarkdownService,
                markdownModuleConfig.loader,
                markdownModuleConfig.markedOptions || exports.initialMarkedOptions,
            ],
        };
    };
    MarkdownModule.forChild = function () {
        return {
            ngModule: MarkdownModule,
        };
    };
    MarkdownModule.decorators = [
        { type: core_1.NgModule, args: [{
                    exports: [
                        language_pipe.LanguagePipe,
                        markdown_component.MarkdownComponent,
                        markdown_pipe.MarkdownPipe,
                    ],
                    declarations: [
                        language_pipe.LanguagePipe,
                        markdown_component.MarkdownComponent,
                        markdown_pipe.MarkdownPipe,
                    ],
                },] },
    ];
    return MarkdownModule;
}());
exports.MarkdownModule = MarkdownModule;

});

unwrapExports(markdown_module);
var markdown_module_1 = markdown_module.initialMarkedOptions;
var markdown_module_2 = markdown_module.MarkdownModule;

var markedRenderer = createCommonjsModule(function (module, exports) {
var __extends = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });

var MarkedRenderer = /** @class */ (function (_super) {
    __extends(MarkedRenderer, _super);
    function MarkedRenderer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return MarkedRenderer;
}(marked.Renderer));
exports.MarkedRenderer = MarkedRenderer;

});

unwrapExports(markedRenderer);
var markedRenderer_1 = markedRenderer.MarkedRenderer;

var lib = createCommonjsModule(function (module, exports) {
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(language_pipe);
__export(markdown_component);
__export(markdown_module);
__export(markdown_pipe);
__export(markdown_service);
__export(markedOptions);
__export(markedRenderer);

});

var index = unwrapExports(lib);

return index;

})));
